/**
  ******************************************************************************
  * @file    sh3xf2xx_sa0_int.c 
  * @author  
  * @version V1.1.0
  * @date    15-April-2016
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "sh3xf2xx_sa0_int.h"

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */  
/* NMI ISR Handler template, uncomment it for using*/
/*void NMI_Handler(void)
{
}*/

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void HardFault_Handler(void)
//{
//  /* Go to infinite loop when Hard Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
/* Memory Manage ISR Handler template, uncomment it for using*/
//void MemManage_Handler(void)
//{
//  /* Go to infinite loop when Memory Manage exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
/* Bus Fault ISR Handler template, uncomment it for using*/
//void BusFault_Handler(void)
//{
//  /* Go to infinite loop when Bus Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
/* Usage Fault ISR Handler template, uncomment it for using*/
//void UsageFault_Handler(void)
//{
//  /* Go to infinite loop when Usage Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
/*void SVC_Handler(void)
{
}*/

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
/*void DebugMon_Handler(void)
{
}*/

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
/*void PendSV_Handler(void)
{
}*/

/**
  * @brief  This function handles SysTick exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
/*void SysTick_Handler(void)
{
}*/

/******************************************************************************/
/*                 SH32F205 Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_sh3xf2xx_sa0_xxx.s).                                               */
/******************************************************************************/

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */

/*
void WWDT_Handler       (void)
{
}
*/

/*
void BOD_Handler        (void);
{
}
*/

/*
void RCC_Handler        (void);
{
}
*/

/*
void EXTI0_Handler      (void);
{
}
*/

/*
void EXTI1_Handler      (void);
{
}
*/

/*
void EXTI2_Handler      (void);
{
}
*/

/*
void EXTI3_Handler      (void);
{
}
*/

/*
void EXTI4_Handler      (void);
{
}
*/

/*
void DMA_CH0_Handler    (void);
{
}
*/

/*
void DMA_CH1_Handler    (void);
{
}
*/

/*
void DMA_CH2_7_Handler  (void);
{
}
*/

/*
void MCM1_FLT_Handler   (void); 
{
}
*/

/*
void MCM1_PWM_Handler   (void); 
{
}
*/

/*
void MCM2_FLT_Handler   (void); 
{
}
*/

/*
void MCM2_PWM_Handler   (void); 
{
}
*/

/*
void ADC1_Handler       (void);
{
}
*/

/*
void ADC2_Handler       (void);
{
}
*/

/*
void ADC3_Handler       (void);
{
}
*/

/*
void GPT0_GTCIV_Handler (void);
{
}
*/

/*
void GPT0_GTCIN_Handler (void);
{
}
*/

/*
void GPT1_GTCIV_Handler (void);
{
}
*/

/*
void GPT1_GTCIN_Handler (void);
{
}
*/

/*
void GPT2_GTCIV_Handler (void);
{
}
*/

/*
void GPT2_GTCIN_Handler (void);
{
}
*/

/*
void GPT3_GTCIV_Handler (void);
{
}
*/

/*
void GPT3_GTCIN_Handler (void);
{
}
*/

/*
void GPT_POE_Handler    (void);
{
}
*/

/*
void EXTI9_5_Handler    (void);
{
}
*/

/*
void CMP1_Handler       (void);
{
}
*/

/*
void CMP2_Handler       (void);
{
}
*/

/*
void CMP3_Handler       (void);
{
}
*/

/*
void QEI_Handler        (void);
{
}
*/

/*
void TWI_Handler        (void);
{
}
*/

/*
void SPI1_Handler       (void);
{
}
*/

/*
void SPI2_Handler       (void);
{
}
*/

/*
void UART1_Handler      (void);
{
}
*/

/*
void UART2_Handler      (void);
{
}
*/

/*
void UART3_Handler      (void);
{
}
*/

/*
void EXTI15_10_Handler  (void);
{
}
*/

/*
void TIM5_Handler       (void);
{
}
*/

/*
void TIM6_Handler       (void);
{
}
*/

/*
void TIM7_Handler       (void);
{
}
*/

/*
void TIM8_Handler       (void);
{
}
*/


/**
  * @}
  */ 


/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
