/**
  ******************************************************************************
  * @file    system_sh3xf2xx_sb0.h
  * @author  sinowealth
  * @version V1.0.0
  * @date    07-March-2021 
  * @brief   This file contains all the functions prototypes for the SH32F2xx firmware
  *          library.
  ******************************************************************************
  * @attention
  *
  * COPYRIGHT 2021 Sinowealth
  *
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SYSTEM_SH3XF2XX_SB0_H_
#define __SYSTEM_SH3XF2XX_SB0_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*********************************Includes**********************************/
#ifdef _RTE_
#include "RTE_Components.h"    
#include CMSIS_device_header
#endif

/** @addtogroup SH3xF2xx_sb0_StdLib_Driver
  * @{
  */

/** @addtogroup Retarget_Group
  * @{
  */ 

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/


/** @addtogroup Retarget_Group_Pub_Funcs
  * @{
  */
     
     
/*! Do System clock initialization in this function */
extern void SystemInit(void);

/**
  * @}
  */ 
  
  
/**
  * @}
  */ 
  
  
/**
  * @}
  */ 
    
#ifdef __cplusplus
}
#endif

#endif /*__SYSTEM_SH3XF2XX_SB0_H_ */

/**
  * @}
  */ 

/**
  * @}
  */ 

/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
