;/*****************************************************************************/
;/* startup_sh32f2xx_keil.s: Startup file for Sinowealth SH32F2 device series */
;/*****************************************************************************/
;/* <<< Use Configuration Wizard in Context Menu >>>                          */ 
;/*****************************************************************************/
;/* This file is part of the uVision/ARM development tools.                   */
;/* Copyright (c) 2005-2007 Keil Software. All rights reserved.               */
;/* This software may only be used under the terms of a valid, current,       */
;/* end user licence from KEIL for a compatible version of KEIL software      */
;/* development tools. Nothing else gives you the right to use this software. */
;/*****************************************************************************/
; *
; * SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S 
; * MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
; * THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
; * SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
; * WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
; * THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
; * CONNECTION WITH THEIR PRODUCTS.
; *
; * COPYRIGHT 2017 Sinowealth
; *
; ******************************************************************************
; */

;<e>Run Application in User Mode
USER_MODE_EN      EQU  0
;</e>

;// <h> Stack Configuration
;   <o0>System Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
;   <o1>User Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
;// </h> 
SystemStack_Size  EQU     0x00000400
UserStack_Size    EQU     0x00000000

		  AREA    STACK, NOINIT, READWRITE, ALIGN=3
__stack_limit		  
System_Stack_Mem  SPACE   SystemStack_Size
system_stack_top
__user_stack_limit
User_Stack_Mem    SPACE   UserStack_Size
usr_stack_top
__initial_sp

;// <h> Heap Configuration
;//   <o>  Heap Size (in Bytes) <0x0-0xFFFFFFFF>
;// </h>
Heap_Size        EQU     0x00000200

;/*****************************************************************************/
;/*-------- <<< end of configuration section >>> -----------------------------*/
;/*****************************************************************************/

                 AREA    HEAP, NOINIT, READWRITE, ALIGN=3
__heap_base
Heap_Mem         SPACE   Heap_Size
__heap_limit

                PRESERVE8
                THUMB
; Vector Table Mapped to Address 0 at Reset
                         AREA     RESET, DATA, READONLY
                         EXPORT   __Vectors
                         EXPORT   __Vectors_End
                         EXPORT   __Vectors_Size
__Vectors
                         DCD      system_stack_top     ; -16 (000H) Top of Stack
                         DCD      Reset_Handler        ; -15 (004H) Reset Handler
                         DCD      NMI_Handler          ; -14 (008H) Non Maskable Interrupt
                         DCD      HardFault_Handler    ; -13 (00CH) Hard Fault Interrupt
                         DCD      MemManage_Handler    ; -12 (010H) Cortex-M3 Memory Management Interrupt
                         DCD      BusFault_Handler     ; -11 (014H) Cortex-M3 Bus Fault Interrupt
                         DCD      UsageFault_Handler   ; -10 (018H) Cortex-M3 Usage Fault Interrupt
                         DCD      Default_Handler      ;  -9 (01CH) Reserved
                         DCD      Default_Handler      ;  -8 (020H) Reserved
                         DCD      Default_Handler      ;  -7 (024H) Reserved
                         DCD      Default_Handler      ;  -6 (028H) Reserved
                         DCD      SVC_Handler          ;  -5 (02CH) Cortex-M3 SV Call Interrupt
                         DCD      DebugMon_Handler     ;  -4 (030H) Cortex-M3 Debug Monitor Interrupt
                         DCD      Default_Handler      ;  -3 (034H) Reserved
                         DCD      PendSV_Handler       ;  -2 (038H) Cortex-M3 Pend SV Interrupt
                         DCD      SysTick_Handler      ;  -1 (03CH) Cortex-M3 System Tick Interrupt
                         DCD      WWDT_Handler         ;   0 (040H) Window WatchDog Interrupt
                         DCD      BOD_Handler          ;   1 (044H) PVD through EXTI Line detection Interrupt
                         DCD      RCC_Handler          ;   2 (048H) RCC global Interrupt
                         DCD      EXTI0_Handler        ;   3 (04CH) EXTI Line0 Interrupt
                         DCD      EXTI1_Handler        ;   4 (050H) EXTI Line1 Interrupt
                         DCD      EXTI2_Handler        ;   5 (054H) EXTI Line2 Interrupt
                         DCD      EXTI3_Handler        ;   6 (058H) EXTI Line3 Interrupt
                         DCD      MCM_FLT_Handler      ;   7 (05CH) MCM FAULT Interrupt
                         DCD      MCM_PWM_Handler      ;   8 (060H) MCM PWM Interrupt
                         DCD      ADC_Handler          ;   9 (064H) ADC Interrupt
                         DCD      PCA0_Handler         ;  10 (068H) PCA0 Interrupt
                         DCD      PCA1_Handler         ;  11 (06CH) PCA1 Interrupt
                         DCD      PCA0_FLT_Handler     ;  12 (070H) PCA0 Fault Interrupt
                         DCD      PCA1_FLT_Handler     ;  13 (074H) PCA1 Fault Interrupt
                         DCD      CMP0_Handler         ;  14 (078H) CMP0 Interrupt
                         DCD      CMP1_Handler         ;  15 (07CH) CMP1 Interrupt
                         DCD      QEI_Handler          ;  16 (080H) QEI Interrupt
                         DCD      CAN_Handler          ;  17 (084H) CAN Interrupt
                         DCD      TWI_Handler          ;  18 (088H) TWI Interrupt
                         DCD      SPI_Handler          ;  19 (08CH) SPI Interrupt
                         DCD      UART0_Handler        ;  20 (090H) UART0 Interrupt
                         DCD      UART1_Handler        ;  21 (094H) UART1 Interrupt
                         DCD      UART2_Handler        ;  22 (098H) UART2 Interrupt
                         DCD      TIM7_Handler         ;  23 (09CH) TIM7 Interrupt
                         DCD      TIM8_Handler         ;  24 (0A0H) TIM8 Interrupt
                         DCD      EXTI7_4_Handler      ;  25 (0A4H) EXTI Line4 ~ Line7 Interrupt
                         DCD      FIFO0_Handler        ;  26 (0A8H) FIFO0 Interrupt
                         DCD      FIFO1_Handler        ;  27 (0ACH) FIFO1 Interrupt
                         DCD      FIFO2_Handler        ;  28 (0B0H) FIFO2 Interrupt


__Vectors_End
__Vectors_Size           EQU      __Vectors_End - __Vectors

                         AREA     |.text|, CODE, READONLY
Reset_Handler            PROC
                         EXPORT   Reset_Handler        [WEAK]
                         IMPORT   __main
				                 LDR      R0, =__stack_limit
        				         MSR      MSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI
                         
                         LDR      R0, =SystemInit
                         BLX      R0
               IF  USER_MODE_EN = 1
                         ;switch to user mode
                         LDR      R0, =usr_stack_top
                         MSR      PSP, R0                                      
				                 LDR      R0, =__user_stack_limit
        				         MSR      PSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI
                         MOV      R0,  #3
                         MSR      CONTROL, R0         
               ENDIF                         
                         LDR      R0, =__main
                         BX       R0
                         ENDP    

NMI_Handler              PROC
                         EXPORT   NMI_Handler          [WEAK]
                         B        .
                         ENDP    

HardFault_Handler        PROC
                         EXPORT   HardFault_Handler    [WEAK]
                         B        .
                         ENDP    

MemManage_Handler        PROC
                         EXPORT   MemManage_Handler    [WEAK]
                         B        .
                         ENDP    

BusFault_Handler         PROC
                         EXPORT   BusFault_Handler     [WEAK]
                         B        .
                         ENDP    

UsageFault_Handler       PROC
                         EXPORT   UsageFault_Handler   [WEAK]
                         B        .
                         ENDP    

SVC_Handler              PROC
                         EXPORT   SVC_Handler          [WEAK]
                 IF  USER_MODE_EN = 1
                         ;instruction svc push xPSR,PC,LR,R12,R3,R2,R1,R0
                         TST      LR,   #0x4         ;test return addr bit 2
                         ITE      EQ                 ;if 0
                         MRSEQ    R0,    MSP         ; use main stack
                         MRSNE    R0,    PSP         ; use user stack
                         B        SVC_Call_Proc
                ELSE
                         B        .
                ENDIF
                         ENDP    
                IF  USER_MODE_EN = 1
SVC_Call_Proc            PROC
                         EXPORT   SVC_Call_Proc       [WEAK]
                         BX       LR
                         ENDP
                ENDIF

DebugMon_Handler         PROC
                         EXPORT   DebugMon_Handler     [WEAK]
                         B        .
                         ENDP    

PendSV_Handler           PROC
                         EXPORT   PendSV_Handler       [WEAK]
                         B        .
                         ENDP    

SysTick_Handler          PROC
                         EXPORT   SysTick_Handler      [WEAK]
                         B        .
                         ENDP    

Default_Handler          PROC
                         EXPORT   WWDT_Handler         [WEAK]
                         EXPORT   BOD_Handler          [WEAK]
                         EXPORT   RCC_Handler          [WEAK]
                         EXPORT   EXTI0_Handler        [WEAK]
                         EXPORT   EXTI1_Handler        [WEAK]
                         EXPORT   EXTI2_Handler        [WEAK]
                         EXPORT   EXTI3_Handler        [WEAK]
                         EXPORT   MCM_FLT_Handler      [WEAK]
                         EXPORT   MCM_PWM_Handler      [WEAK]
                         EXPORT   ADC_Handler          [WEAK]
                         EXPORT   PCA0_Handler         [WEAK]
                         EXPORT   PCA1_Handler         [WEAK]
                         EXPORT   PCA0_FLT_Handler     [WEAK]
                         EXPORT   PCA1_FLT_Handler     [WEAK]
                         EXPORT   CMP0_Handler         [WEAK]
                         EXPORT   CMP1_Handler         [WEAK]
                         EXPORT   QEI_Handler          [WEAK]
                         EXPORT   CAN_Handler          [WEAK]
                         EXPORT   TWI_Handler          [WEAK]
                         EXPORT   SPI_Handler          [WEAK]
                         EXPORT   UART0_Handler        [WEAK]
                         EXPORT   UART1_Handler        [WEAK]
                         EXPORT   UART2_Handler        [WEAK]
                         EXPORT   TIM7_Handler         [WEAK]
                         EXPORT   TIM8_Handler         [WEAK]
                         EXPORT   EXTI7_4_Handler      [WEAK]
                         EXPORT   FIFO0_Handler        [WEAK]
                         EXPORT   FIFO1_Handler        [WEAK]
                         EXPORT   FIFO2_Handler        [WEAK]
WWDT_Handler
BOD_Handler
RCC_Handler
EXTI0_Handler
EXTI1_Handler
EXTI2_Handler
EXTI3_Handler
MCM_FLT_Handler
MCM_PWM_Handler
ADC_Handler
PCA0_Handler
PCA1_Handler
PCA0_FLT_Handler
PCA1_FLT_Handler
CMP0_Handler
CMP1_Handler
QEI_Handler
CAN_Handler
TWI_Handler
SPI_Handler
UART0_Handler
UART1_Handler
UART2_Handler
TIM7_Handler
TIM8_Handler
EXTI7_4_Handler
FIFO0_Handler
FIFO1_Handler
FIFO2_Handler
                         B        .
                         ENDP    

                         
SystemInit  PROC
                EXPORT  SystemInit  [WEAK]
                BX LR      
                ENDP
                    
                ALIGN
                
; User setup Stack & Heap

                EXPORT   __stack_limit
                EXPORT   __initial_sp
                IF       Heap_Size != 0                      ; Heap is provided
                EXPORT   __heap_base
                EXPORT   __heap_limit
                ENDIF

                END
