;/******************************************************************************/
;/* startup_sh32f2811_gcc.s: Startup file for Sinowealth SH32f2601 device series */
;/******************************************************************************/
;/* This file is generated for gcc compiler                                    */
;/******************************************************************************/
;/*	                                                                             */
;/* SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S    */
;/* MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS.   */
;/* THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH */
;/* SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES   */
;/* WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR  */
;/* THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN      */
;/* CONNECTION WITH THEIR PRODUCTS.                                              */
;/*                                                                              */
;/* <h2><center>&copy; COPYRIGHT 2017 Sinowealth</center></h2>                   */
;/*                                                                              */
;/********************************************************************************/
;/********************************************************************************/

    .syntax unified
    .cpu cortex-m3
    .thumb
    
    .global    Reset_Handler

    .section  .data.stack,"w"
.skip  0x400   /*stack size*/
_estack:

   
    .section  .isr_vector ,"a",%progbits
     .long    _estack              ;/* -16 (000H) Top of Stack                                  */
     .long    Reset_Handler        ;/* -15 (004H) Reset Handler                                 */
     .long    NMI_Handler          ;/* -14 (008H) Non Maskable Interrupt                        */
     .long    HardFault_Handler    ;/* -13 (00CH) Hard Fault Interrupt                          */
     .long    MemManage_Handler    ;/* -12 (010H) Cortex-M3 Memory Management Interrupt         */
     .long    BusFault_Handler     ;/* -11 (014H) Cortex-M3 Bus Fault Interrupt                 */
     .long    UsageFault_Handler   ;/* -10 (018H) Cortex-M3 Usage Fault Interrupt               */
     .long    Default_Handler      ;/*  -9 (01CH) Reserved                                      */
     .long    Default_Handler      ;/*  -8 (020H) Reserved                                      */
     .long    Default_Handler      ;/*  -7 (024H) Reserved                                      */
     .long    Default_Handler      ;/*  -6 (028H) Reserved                                      */
     .long    SVC_Handler          ;/*  -5 (02CH) Cortex-M3 SV Call Interrupt                   */
     .long    DebugMon_Handler     ;/*  -4 (030H) Cortex-M3 Debug Monitor Interrupt             */
     .long    Default_Handler      ;/*  -3 (034H) Reserved                                      */
     .long    PendSV_Handler       ;/*  -2 (038H) Cortex-M3 Pend SV Interrupt                   */
     .long    SysTick_Handler      ;/*  -1 (03CH) Cortex-M3 System Tick Interrupt               */
     .long    WWDT_Handler         ;/*   0 (040H) Window WatchDog Interrupt                     */
     .long    BOD_Handler          ;/*   1 (044H) PVD through EXTI Line detection Interrupt     */
     .long    RCC_Handler          ;/*   2 (048H) RCC global Interrupt                          */
     .long    EXTI0_Handler        ;/*   3 (04CH) EXTI Line0 Interrupt                          */
     .long    EXTI1_Handler        ;/*   4 (050H) EXTI Line1 Interrupt                          */
     .long    EXTI2_Handler        ;/*   5 (054H) EXTI Line2 Interrupt                          */
     .long    EXTI3_Handler        ;/*   6 (058H) EXTI Line3 Interrupt                          */
     .long    MCM_FLT_Handler      ;/*   7 (05CH) MCM FAULT Interrupt                           */
     .long    MCM_PWM_Handler      ;/*   8 (060H) MCM PWM Interrupt                             */
     .long    ADC_Handler          ;/*   9 (064H) ADC Interrupt                                 */
     .long    PCA0_Handler         ;/*  10 (068H) PCA0 Interrupt                                */
     .long    PCA1_Handler         ;/*  11 (06CH) PCA1 Interrupt                                */
     .long    PCA0_FLT_Handler     ;/*  12 (070H) PCA0 Fault Interrupt                          */
     .long    PCA1_FLT_Handler     ;/*  13 (074H) PCA1 Fault Interrupt                          */
     .long    CMP0_Handler         ;/*  14 (078H) CMP0 Interrupt                                */
     .long    CMP1_Handler         ;/*  15 (07CH) CMP1 Interrupt                                */
     .long    QEI_Handler          ;/*  16 (080H) QEI Interrupt                                 */
     .long    CAN_Handler          ;/*  17 (084H) CAN Interrupt                                 */
     .long    TWI_Handler          ;/*  18 (088H) TWI Interrupt                                 */
     .long    SPI_Handler          ;/*  19 (08CH) SPI Interrupt                                 */
     .long    UART0_Handler        ;/*  20 (090H) UART0 Interrupt                               */
     .long    UART1_Handler        ;/*  21 (094H) UART1 Interrupt                               */
     .long    UART2_Handler        ;/*  22 (098H) UART2 Interrupt                               */
     .long    TIM7_Handler         ;/*  23 (09CH) TIM7 Interrupt                                */
     .long    TIM8_Handler         ;/*  24 (0A0H) TIM8 Interrupt                                */
     .long    EXTI7_4_Handler      ;/*  25 (0A4H) EXTI Line4 ~ Line7 Interrupt                  */
     .long    FIFO0_Handler        ;/*  26 (0A8H) FIFO0 Interrupt                               */
     .long    FIFO1_Handler        ;/*  27 (0ACH) FIFO1 Interrupt                               */
     .long    FIFO2_Handler        ;/*  28 (0B0H) FIFO2 Interrupt                               */
    
      .section  .text.Reset_Handler,"ax",%progbits
      .type Reset_Handler, %function
Reset_Handler:
    ldr  sp, =_estack

    /* Call the low level init function.*/
    bl  SystemInit   
    
    movs r1, #0
    b    LoopCopyDataInit

CopyDataInit:
    ldr  r3, =_sidata
    ldr  r3, [r3, r1]
    str  r3, [r0, r1]
    adds r1, r1, #4
    
LoopCopyDataInit:
    ldr  r0, =_sdata
    ldr  r3, =_edata
    adds r2, r0, r1
    cmp  r2, r3
    bcc  CopyDataInit
    ldr  r2, =_sbss
    b    LoopFillZerobss
  
    ;/* Zero fill the bss segment. */  

FillZerobss:
    movs r3, #0
    str  r3, [r2], #4
    
LoopFillZerobss:
    ldr r3, =_ebss
    cmp r2, r3
    bcc FillZerobss
  
   /* Call static constructors */
   /* bl  __libc_init_array*/
	
  /* Call the application's entry point.*/
    bl  main
    bx  lr    
    b  .  
    
    .size  Reset_Handler, .-Reset_Handler
    
    .weak      NMI_Handler
    .thumb_set NMI_Handler,          System_Handler
  
    .weak      HardFault_Handler
    .thumb_set HardFault_Handler,    System_Handler
  
    .weak      MemManage_Handler
    .thumb_set MemManage_Handler,    System_Handler
  
    .weak      BusFault_Handler
    .thumb_set BusFault_Handler,     System_Handler

    .weak      UsageFault_Handler
    .thumb_set UsageFault_Handler,   System_Handler

    .weak      SVC_Handler
    .thumb_set SVC_Handler,          System_Handler

    .weak      DebugMon_Handler
    .thumb_set DebugMon_Handler,     System_Handler

    .weak      PendSV_Handler
    .thumb_set PendSV_Handler,       System_Handler

    .weak      SysTick_Handler
    .thumb_set SysTick_Handler,      System_Handler    

    .weak      WWDT_Handler        
    .thumb_set WWDT_Handler,        User_Handler
    .weak      BOD_Handler         
    .thumb_set BOD_Handler,         User_Handler
    .weak      RCC_Handler         
    .thumb_set RCC_Handler,         User_Handler
    .weak      EXTI0_Handler       
    .thumb_set EXTI0_Handler,       User_Handler
    .weak      EXTI1_Handler       
    .thumb_set EXTI1_Handler,       User_Handler
    .weak      EXTI2_Handler       
    .thumb_set EXTI2_Handler,       User_Handler
    .weak      EXTI3_Handler       
    .thumb_set EXTI3_Handler,       User_Handler
    .weak      MCM_FLT_Handler     
    .thumb_set MCM_FLT_Handler,     User_Handler
    .weak      MCM_PWM_Handler     
    .thumb_set MCM_PWM_Handler,     User_Handler
    .weak      ADC_Handler         
    .thumb_set ADC_Handler,         User_Handler
    .weak      PCA0_Handler        
    .thumb_set PCA0_Handler,        User_Handler
    .weak      PCA1_Handler        
    .thumb_set PCA1_Handler,        User_Handler
    .weak      PCA0_FLT_Handler    
    .thumb_set PCA0_FLT_Handler,    User_Handler
    .weak      PCA1_FLT_Handler    
    .thumb_set PCA1_FLT_Handler,    User_Handler
    .weak      CMP0_Handler        
    .thumb_set CMP0_Handler,        User_Handler
    .weak      CMP1_Handler        
    .thumb_set CMP1_Handler,        User_Handler
    .weak      QEI_Handler         
    .thumb_set QEI_Handler,         User_Handler
    .weak      CAN_Handler         
    .thumb_set CAN_Handler,         User_Handler
    .weak      TWI_Handler         
    .thumb_set TWI_Handler,         User_Handler
    .weak      SPI_Handler         
    .thumb_set SPI_Handler,         User_Handler
    .weak      UART0_Handler       
    .thumb_set UART0_Handler,       User_Handler
    .weak      UART1_Handler       
    .thumb_set UART1_Handler,       User_Handler
    .weak      UART2_Handler       
    .thumb_set UART2_Handler,       User_Handler
    .weak      TIM7_Handler        
    .thumb_set TIM7_Handler,        User_Handler
    .weak      TIM8_Handler        
    .thumb_set TIM8_Handler,        User_Handler
    .weak      EXTI7_4_Handler     
    .thumb_set EXTI7_4_Handler,     User_Handler
    .weak      FIFO0_Handler       
    .thumb_set FIFO0_Handler,       User_Handler
    .weak      FIFO1_Handler       
    .thumb_set FIFO1_Handler,       User_Handler
    .weak      FIFO2_Handler       
    .thumb_set FIFO2_Handler,       User_Handler
   
    .section  .text.System_Handler,"ax",%progbits
    .type System_Handler, %function
System_Handler:
   b  .
   .size  System_Handler, .-System_Handler
   
    .section  .text.Default_Handler,"ax",%progbits
    .type Default_Handler, %function
Default_Handler:
   b  .   
   .size  Default_Handler, .-Default_Handler

 
    .section  .text.User_Handler,"ax",%progbits
    .type User_Handler, %function
User_Handler:
   b  .
   .size  User_Handler, .-User_Handler
               
   .weak SystemInit
   .thumb_set SystemInit, SystemInit_Default
   .section  .text.SystemInit,"ax",%progbits   
   .type SystemInit_Default, %function
SystemInit_Default:
   bx lr
   .size SystemInit_Default, .-SystemInit_Default
   

