/**
  ******************************************************************************
  * @file    sh3xf2xx_sb0_int.c 
  * @author  
  * @version V1.1.0
  * @date    07-March-2021
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "sh3xf2xx_sb0_int.h"

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            ARM Star Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */  
/* NMI ISR Handler template, uncomment it for using*/
//void NMI_Handler(void)
//{
//}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void HardFault_Handler(void)
//{
//  /* Go to infinite loop when Hard Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
/* Memory Manage ISR Handler template, uncomment it for using*/
//void MemManage_Handler(void)
//{
  /* Go to infinite loop when Memory Manage exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
/* Bus Fault ISR Handler template, uncomment it for using*/
//void BusFault_Handler(void)
//{
  /* Go to infinite loop when Bus Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
/* Usage Fault ISR Handler template, uncomment it for using*/
//void UsageFault_Handler(void)
//{
  /* Go to infinite loop when Usage Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void SVC_Handler(void)
//{
//}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void DebugMon_Handler(void)
//{
//}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void PendSV_Handler(void)
//{
//}

/**
  * @brief  This function handles SysTick exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void SysTick_Handler(void)
//{
//}

/******************************************************************************/
/*                 SH32F205 Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_sh32f205_xxx.s).                                               */
/******************************************************************************/

/**
  * @brief  This function handles WWDT interrupt request.
  * @param  None
  * @retval None
  */
//void WWDT_Handler      (void) //   0 (040H) Window WatchDog Interrupt
//{
//}

/**
  * @brief  This function handles BOD interrupt request.
  * @param  None
  * @retval None
  */
//void BOD_Handler       (void) //   1 (044H) PVD through EXTI Line detection Interrupt
//{
//}

/**
  * @brief  This function handles RCC interrupt request.
  * @param  None
  * @retval None
  */
//void RCC_Handler       (void) //   2 (048H) RCC global Interrupt
//{
//}

/**
  * @brief  This function handles EXTI0 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI0_Handler     (void) //   3 (04CH) EXTI Line0 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI1 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI1_Handler     (void) //   4 (050H) EXTI Line1 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI2 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI2_Handler     (void) //   5 (054H) EXTI Line2 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI3 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI3_Handler     (void) //   6 (058H) EXTI Line3 Interrupt
//{
//}

/**
  * @brief  This function handles MCM Fault interrupt request.
  * @param  None
  * @retval None
  */
//void MCM_FLT_Handler   (void) //   7 (05CH) MCM FAULT Interrupt
//{
//}

/**
  * @brief  This function handles MCM interrupt request.
  * @param  None
  * @retval None
  */
//void MCM_PWM_Handler   (void) //   8 (060H) MCM PWM Interrupt
//{
//}

/**
  * @brief  This function handles ADC interrupt request.
  * @param  None
  * @retval None
  */
//void ADC_Handler       (void) //   9 (064H) ADC Interrupt
//{
//}

/**
  * @brief  This function handles PCA0 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA0_Handler      (void) //  10 (068H) PCA0 Interrupt
//{
//}

/**
  * @brief  This function handles PCA1 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA1_Handler      (void) //  11 (06CH) PCA1 Interrupt
//{
//}

/**
  * @brief  This function handles PCA0 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA0_FLT_Handler  (void) //  12 (070H) PCA0 Fault Interrupt
//{
//}

/**
  * @brief  This function handles PCA1 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA1_FLT_Handler  (void) //  13 (074H) PCA1 Fault Interrupt
//{
//}

/**
  * @brief  This function handles CMP0_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void CMP0_Handler      (void) //  14 (078H) CMP0 Interrupt
//{
//}

/**
  * @brief  This function handles CMP1_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void CMP1_Handler      (void) //  15 (07CH) CMP1 Interrupt
//{
//}

/**
  * @brief  This function handles QEI_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void QEI_Handler       (void) //  16 (080H) QEI Interrupt
//{
//}

/**
  * @brief  This function handles CAN_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void CAN_Handler       (void) //  17 (084H) CAN Interrupt
//{
//}

/**
  * @brief  This function handles TWI_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void TWI_Handler       (void) //  18 (088H) TWI Interrupt
//{
//}

/**
  * @brief  This function handles SPI_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void SPI_Handler       (void) //  19 (08CH) SPI Interrupt
//{
//}

/**
  * @brief  This function handles UART0_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void UART0_Handler     (void) //  20 (090H) UART0 Interrupt
//{
//}

/**
  * @brief  This function handles UART1_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void UART1_Handler     (void) //  21 (094H) UART1 Interrupt
//{
//}

/**
  * @brief  This function handles UART2_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void UART2_Handler     (void) //  22 (098H) UART2 Interrupt
//{
//}

/**
  * @brief  This function handles TIM7_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void TIM7_Handler      (void) //  23 (09CH) TIM7 Interrupt
//{
//}

/**
  * @brief  This function handles TIM8_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void TIM8_Handler      (void) //  24 (0A0H) TIM8 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI4_7_Handler interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI7_4_Handler   (void) //  25 (0A4H) EXTI Line4 ~ Line7 Interrupt
//{
//}

/**
  * @brief  This function handles FIFO0 interrupt request.
  * @param  None
  * @retval None
  */
//void FIFO0_Handler     (void) //  26 (0A8H) FIFO0 Interrupt
//{
//}

/**
  * @brief  This function handles FIFO1 interrupt request.
  * @param  None
  * @retval None
  */
//void FIFO1_Handler     (void) //  27 (0ACH) FIFO1 Interrupt
//{
//}

/**
  * @brief  This function handles FIFO2 interrupt request.
  * @param  None
  * @retval None
  */
//void FIFO2_Handler     (void) //  28 (0B0H) FIFO2 Interrupt
//{
//}

/**
  * @}
  */ 


/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
