/**
  ******************************************************************************
  * @file    sh3xf2xx_sb0_int.h 
  * @author  
  * @version V1.1.0
  * @date    07-March-2021
  * @brief   This file contains the headers of the interrupt handlers.
  ******************************************************************************
  */ 

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SH3xf2xx_sb0_INT_H__
#define __SH3xf2xx_sb0_INT_H__

#ifdef __cplusplus
 extern "C" {
#endif 

/* Includes ------------------------------------------------------------------*/
#ifdef _RTE_
#include "RTE_Components.h"    
#include CMSIS_device_header
#endif

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

extern void NMI_Handler(void);
extern void HardFault_Handler(void);
extern void MemManage_Handler(void);
extern void BusFault_Handler(void);
extern void UsageFault_Handler(void);
extern void SVC_Handler(void);
extern void DebugMon_Handler(void);
extern void PendSV_Handler(void);
extern void SysTick_Handler(void);

extern void WWDT_Handler      (void); //   0 (040H) Window WatchDog Interrupt
extern void BOD_Handler       (void); //   1 (044H) PVD through EXTI Line detection Interrupt
extern void RCC_Handler       (void); //   2 (048H) RCC global Interrupt
extern void EXTI0_Handler     (void); //   3 (04CH) EXTI Line0 Interrupt
extern void EXTI1_Handler     (void); //   4 (050H) EXTI Line1 Interrupt
extern void EXTI2_Handler     (void); //   5 (054H) EXTI Line2 Interrupt
extern void EXTI3_Handler     (void); //   6 (058H) EXTI Line3 Interrupt
extern void MCM_FLT_Handler   (void); //   7 (05CH) MCM FAULT Interrupt
extern void MCM_PWM_Handler   (void); //   8 (060H) MCM PWM Interrupt
extern void ADC_Handler       (void); //   9 (064H) ADC Interrupt
extern void PCA0_Handler      (void); //  10 (068H) PCA0 Interrupt
extern void PCA1_Handler      (void); //  11 (06CH) PCA1 Interrupt
extern void PCA0_FLT_Handler  (void); //  12 (070H) PCA0 Fault Interrupt
extern void PCA1_FLT_Handler  (void); //  13 (074H) PCA1 Fault Interrupt
extern void CMP0_Handler      (void); //  14 (078H) CMP0 Interrupt
extern void CMP1_Handler      (void); //  15 (07CH) CMP1 Interrupt
extern void QEI_Handler       (void); //  16 (080H) QEI Interrupt
extern void CAN_Handler       (void); //  17 (084H) CAN Interrupt
extern void TWI_Handler       (void); //  18 (088H) TWI Interrupt
extern void SPI_Handler       (void); //  19 (08CH) SPI Interrupt
extern void UART0_Handler     (void); //  20 (090H) UART0 Interrupt
extern void UART1_Handler     (void); //  21 (094H) UART1 Interrupt
extern void UART2_Handler     (void); //  22 (098H) UART2 Interrupt
extern void TIM7_Handler      (void); //  23 (09CH) TIM7 Interrupt
extern void TIM8_Handler      (void); //  24 (0A0H) TIM8 Interrupt
extern void EXTI7_4_Handler   (void); //  25 (0A4H) EXTI Line4 ~ Line7 Interrupt
extern void FIFO0_Handler     (void); //  26 (0A8H) FIFO0 Interrupt
extern void FIFO1_Handler     (void); //  27 (0ACH) FIFO1 Interrupt
extern void FIFO2_Handler     (void); //  28 (0B0H) FIFO2 Interrupt

#ifdef __cplusplus
}
#endif

#endif /* __SH3xf2xx_sb0_INT_H__ */

/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
